### Method

# Fwupd Client download_bytes_async

#### Declaration [src]

    void
    fwupd_client_download_bytes_async (
      FwupdClient* self,
      const gchar* url,
      FwupdClientDownloadFlags flags,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer callback_data
    )

#### Description [src]

Downloads data from a remote server. The `fwupd_client_set_user_agent()` function should be called before this method is used.

You must have called `fwupd_client_connect_async()` on `self` before using this method.

NOTE: This method is thread-safe, but progress signals will be emitted in the global default main context, if not explicitly set with `fwupd_client_set_main_context()`.

Available since: | 1.5.0

#### Parameters

`url` | `const gchar*`
| The remote URL.
| The data is owned by the caller of the function.
| The value is a NUL terminated UTF-8 string.
`flags` | `FwupdClientDownloadFlags`
| Download flags, e.g. `FWUPD_CLIENT_DOWNLOAD_FLAG_NONE`.
`cancellable` | `GCancellable`
| Optional `GCancellable`.
| The argument can be `NULL`.
| The data is owned by the caller of the function.
`callback` | `GAsyncReadyCallback`
| The function to run on completion.
| The argument can be `NULL`.
`callback_data` | `gpointer`
| The data to pass to `callback`.
| The argument can be `NULL`.
| The data is owned by the caller of the function.